#include <bits/stdc++.h>
using namespace std;
using ll = long long;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<string> h(n), v(n - 1);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m - 1; j++) {
            cin >> h[i][j];
            if (h[i][j] != 'B' && h[i][j] != 'R') f = false;
        }
    }
    for (ll i = 0; i < n - 1; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> v[i][j];
            if (v[i][j] != 'B' && v[i][j] != 'R') f = false;
        }
    }
    vector<vector<vector<vector<ll>>>> pb(n, vector<vector<vector<ll>>>(m, vector<vector<ll>>(n, vector<ll>(m))));
    vector<vector<vector<vector<ll>>>> pr(n, vector<vector<vector<ll>>>(m, vector<vector<ll>>(n, vector<ll>(m))));
    if (f) {
        for (ll is = 0; is < n; is++) {
            for (ll js = 0; js < m; js++) {
                pb[is][js][is][js] = 1;
                queue<pair<ll, ll>> q;
                q.push({is, js});
                while (!q.empty()) {
                    pair<ll, ll> ij = q.front();
                    q.pop();
                    ll i = ij.first, j = ij.second;
                    for (ll ip = -1; ip < 2; ip++) {
                        for (ll jp = -1; jp < 2; jp++) {
                            if (ip != 0 && jp != 0 || (ip == 0 && jp == 0)) continue;
                            ll ni = i + ip, nj = j + jp;
                            if (ni > -1 && ni < n && nj > -1 && nj < m && !pb[is][js][ni][nj]) {
                                char nw;
                                if (ip == 0) nw = h[ni][nj - (jp == 1)];
                                else nw = v[ni - (ip == 1)][nj];
                                if (nw == 'B') {
                                    pb[is][js][ni][nj] = 1;
                                    q.push({ni, nj});
                                }
                            }
                        }
                    }
                }
            }
        }
        for (ll is = 0; is < n; is++) {
            for (ll js = 0; js < m; js++) {
                pr[is][js][is][js] = 1;
                queue<pair<ll, ll>> q;
                q.push({is, js});
                while (!q.empty()) {
                    pair<ll, ll> ij = q.front();
                    q.pop();
                    ll i = ij.first, j = ij.second;
                    for (ll ip = -1; ip < 2; ip++) {
                        for (ll jp = -1; jp < 2; jp++) {
                            if (ip != 0 && jp != 0 || (ip == 0 && jp == 0)) continue;
                            ll ni = i + ip, nj = j + jp;
                            if (ni > -1 && ni < n && nj > -1 && nj < m && !pr[is][js][ni][nj]) {
                                char nw;
                                if (ip == 0) nw = h[ni][nj - (jp == 1)];
                                else nw = v[ni - (ip == 1)][nj];
                                if (nw == 'R') {
                                    pr[is][js][ni][nj] = 1;
                                    q.push({ni, nj});
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    ll q;
    cin >> q;
    for (ll _ = 0; _ < q; _++) {
        ll x, y, x2, y2;
        cin >> x >> y >> x2 >> y2;
        x--, y--, x2--, y2--;
        if (f) {
            if (pb[x][y][x2][y2] || pr[x][y][x2][y2]) cout << 1;
            else cout << 2;
            cout << '\n';
            continue;
        }
        set<pair<vector<ll>, set<char>>> p;
        p.insert({{0, x, y}, {}});
        vector<vector<ll>> r(n, vector<ll>(m, 52));
        vector<vector<set<char>>> sr(n, vector<set<char>>(m));
        r[x][y] = 0;
        while (!p.empty()) {
            pair<vector<ll>, set<char>> cr = *p.begin();
            p.erase(p.begin());
            for (ll ip = -1; ip < 2; ip++) {
                for (ll jp = -1; jp < 2; jp++) {
                    if (ip != 0 && jp != 0 || (ip == 0 && jp == 0)) continue;
                    ll ni = ip + cr.first[1], nj = jp + cr.first[2];
                    if (ni > -1 && ni < n && nj > -1 && nj < m) {
                        char nw;
                        if (ip == 0) nw = h[ni][nj - (jp == 1)];
                        else nw = v[ni - (ip == 1)][nj];
                        ll ne = (cr.second.find(nw) == cr.second.end());
                        if (ne + cr.first[0] <= r[ni][nj] && r[ni][nj]) {
                            p.erase({{r[ni][nj], ni, nj}, sr[ni][nj]});
                            r[ni][nj] = ne + cr.first[0];
                            sr[ni][nj].clear();
                            sr[ni][nj].insert(cr.second.begin(), cr.second.end());
                            sr[ni][nj].insert(nw);
                            p.insert({{r[ni][nj], ni, nj}, sr[ni][nj]});
                        }
                    }
                }
            }
        }
        cout << r[x2][y2] << '\n';
    }
    return 0;
}